import * as pdfjsApi from 'pdfjs-dist/types/display/api';
import 'pdfjs-dist/legacy/web/pdf_viewer.css';
export interface propsType {
    src: string | URL | pdfjsApi.TypedArray | pdfjsApi.PDFDataRangeTransport | pdfjsApi.DocumentInitParameters;
    page: number;
    enableTextSelection: boolean;
    enableAnnotations: boolean;
}
declare const _default: import("vue").DefineComponent<{
    /**
     * The source of the pdf.
     * Accepts `string | URL | TypedArray | PDFDataRangeTransport | DocumentInitParameters`
     */
    src: {
        type: (StringConstructor | ObjectConstructor)[];
        required: true;
    };
    /**
     * The page number of the pdf to display.
     */
    page: {
        type: NumberConstructor;
        default: number;
    };
    /**
     * Whether to enable text selection
     */
    enableTextSelection: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * Whether to enable annotations (clickable links)
     */
    enableAnnotations: {
        type: BooleanConstructor;
        default: boolean;
    };
}, {
    props: propsType;
    pdfWrapperRef: import("vue").Ref<HTMLInputElement | null>;
    parentWrapperRef: import("vue").Ref<HTMLInputElement | null>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
    src?: unknown;
    page?: unknown;
    enableTextSelection?: unknown;
    enableAnnotations?: unknown;
} & {
    src: string | Record<string, any>;
    page: number;
    enableTextSelection: boolean;
    enableAnnotations: boolean;
} & {}>, {
    page: number;
    enableTextSelection: boolean;
    enableAnnotations: boolean;
}>;
export default _default;
